
SELECT TIMESTAMP,
ag.name as [Availability Group Name],
ar.replica_server_name as [Local Replica],
sr.replica_server_name as [Target Replica],
currentState,
targetState
FROM
(SELECT TIMESTAMP,
record.value('(./Record/HadrTransportState/agId)[1]', 'varchar(255)') AS agId,
record.value('(./Record/HadrTransportState/localArId)[1]', 'varchar(255)') AS localArId,
record.value('(./Record/HadrTransportState/targetArId)[1]', 'varchar(255)') AS targetArId,
record.value('(./Record/HadrTransportState/currentState)[1]', 'varchar(255)') AS currentState,
record.value('(./Record/HadrTransportState/targetState)[1]', 'varchar(255)') AS targetState
FROM (
	SELECT TIMESTAMP, CONVERT(XML, record) AS record
	FROM sys.dm_os_ring_buffers
	where ring_buffer_type = 'RING_BUFFER_HADR_TRANSPORT_STATE'
	) rd
) rb
INNER JOIN sys.availability_replicas ar
on rb.localArId = ar.replica_id
INNER JOIN sys.availability_replicas sr
on rb.targetArId = sr.replica_id
INNER JOIN sys.availability_groups ag
on rb.agId = ag.group_id
ORDER BY TIMESTAMP

